dofile ("acessabd.lua")
dofile( "global.lua" )

-- -------------------------------------------------
-- Entrada : codigo do Projeto
-- Saida : Custos Anuais Previstos
-- -------------------------------------------------
function retornaCustoParcial( cod )
   local result = {}   
   if ( cod ) then      
      result = ConsultaBD2( "custo", "custo_ano , custo_prev_ano", "proj_cod = '" .. cod .. "'" , "custo_ano" )
   end
   return result           
end
             
function mostraInfoCustoPorMes ( cod )
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   local sql = "SELECT proj_dt_ini_prev, proj_dt_fim_prev FROM projeto WHERE proj_cod = "..cod
   DBExec(sql)
   local resultado = DBRow()
   if resultado and resultado.proj_dt_ini_prev then
   	proj_dt_ini_prev = resultado.proj_dt_ini_prev
   	proj_dt_fim_prev = resultado.proj_dt_fim_prev
   end   
   tamanho   = {'30%', '50%', '70%', '90%'}
   tab_meses = {'jan','fev','mar','abr','mai','jun','jul','ago','set','out','nov','dez','total anual'}
   mes_ini         = strsub(proj_dt_ini_prev,4,5)
   mes_fim         = strsub(proj_dt_fim_prev,4,5)
   ano_ini         = strsub(proj_dt_ini_prev,7,10)
   ano_fim         = strsub(proj_dt_fim_prev,7,10)
   num_anos        = ( ano_fim - ano_ini ) + 1              
   ult_dig_ano_ini = strsub(ano_ini,4,4)
   ult_dig_ano_fim = strsub(ano_fim,4,4)
   num_anos_fixo   = num_anos   
   
   -- -------------------------------------------------------------------------------------------------
   -- EXIBICAO DOS CAMPOS REFERENTES AO CUSTO ANUAL (DATAS E VALORES) CASO TENHAM SIDO CADASTRADOS 
   -- -------------------------------------------------------------------------------------------------  
   tabela = ''  
   i      = strsub(ano_ini,4,4) 
   i_fixo = i
   
   -- ----------------------------------------------------------------------------------------------------
   -- MONTA CABECALHO DA TABELA COM OS ANOS
   -- ----------------------------------------------------------------------------------------------------
   write('<HR WIDTH=85%>\n' )
   write('<table border="0" align="center"><tr><td class="fieldLabel" align="center" colspan="2">Custo Previsto por Ms</td></tr></table>\n' )
   while num_anos > 0 do
      if tonumber(num_anos) == tonumber(num_anos_fixo) then                                 
         tabela = tabela..'<tr>\n'
         tabela = tabela..'<td width="20%"><b>Ms/Ano</b></td>\n'
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'</td>\n'
      else
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'</td>\n'                 
      end
      if tonumber(num_anos) == 1 then
         tabela = tabela..'</tr>\n'
      end
      i        = i + 1
      num_anos = num_anos - 1                 
   end	

   -- ----------------------------------------------------------------------------------------------------
   -- MONTA MESES
   -- ----------------------------------------------------------------------------------------------------
   j = 1
   while tab_meses[j] do
      i = i_fixo
      num_anos = num_anos_fixo
      while num_anos > 0 do                 
         if tonumber(num_anos) == tonumber(num_anos_fixo) then                                 
            tabela = tabela..'<tr>\n'
            tabela = tabela..'<td width="20%" class="fieldLabel">'..strupper(tab_meses[j])..'</td>\n'
            if j == 13 then
               tab_meses[j] = 'tot_ano'
            end   
            -- ------------------------------------------------------------------
            -- TESTE SE O MES ATUAL DO LOOP  MENOR QUE O MES DA DATA DE INICIO
            -- ------------------------------------------------------------------
            if (tonumber(j) < tonumber(mes_ini)) then
               tabela = tabela..'<td width="20%" align="center">n/a</TD>\n'
            else
               if (tonumber(j) == 13) then
                  local sql = "SELECT sum(valor_real) as total FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND proj_cod = "..tonumber(cod)
                  DBExec(sql)
                  local resultado = DBRow()
                  if resultado and resultado.total then
                     tabela = tabela..'<td width="20%" align="center"><b>'..ponto_centavo(formata_valor(resultado.total))..'</b></td>\n'
                  else
                     tabela = tabela..'<td width="20%" align="center"><b>0,00</b></td>\n'
                  end
               else
                  local sql = "SELECT valor_real FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND month(dt_prevista) = "..j.." AND proj_cod = "..tonumber(cod)
                  DBExec(sql)
                  local resultado = DBRow()
                  if resultado and resultado.valor_real then
                     tabela = tabela..'<td width="20%" align="center">'..ponto_centavo(formata_valor(resultado.valor_real))..'</td>\n'
                  else
                     tabela = tabela..'<td width="20%" align="center">-</td>\n'
                  end
               end
            end
         else
            -- ------------------------------------------------------------------
            -- TESTE SE O MES ATUAL DO LOOP  MAIOR QUE O MES DA DATA DE FIM
            -- ------------------------------------------------------------------
            if (tonumber(i) < tonumber(ult_dig_ano_fim)) then
               if (tonumber(j) == 13) then
                  local sql = "SELECT sum(valor_real) as total FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND proj_cod = "..tonumber(cod)
                  DBExec(sql)
                  local resultado = DBRow()
                  if resultado and resultado.total then
                     tabela = tabela..'<td width="20%" align="center"><b>'..ponto_centavo(formata_valor(resultado.total))..'</b></td>\n'
                  else
                     tabela = tabela..'<td width="20%" align="center"><b>0,00</b></td>\n'
                  end
               else
                  local sql = "SELECT valor_real FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND month(dt_prevista) = "..j.." AND proj_cod = "..tonumber(cod)
                  DBExec(sql)
                  local resultado = DBRow()
                  if resultado and resultado.valor_real then
                     tabela = tabela..'<td width="20%" align="center">'..ponto_centavo(formata_valor(resultado.valor_real))..'</td>\n'
                  else
                     tabela = tabela..'<td width="20%" align="center">-</td>\n'
                  end
               end
            else
               if (tonumber(j) > tonumber(mes_fim)) and (j ~= 13) then
                  tabela = tabela..'<td width="20%" align="center">n/a</TD>\n'
               else                       
                  if (tonumber(j) == 13) then
                     local sql = "SELECT sum(valor_real) as total FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND proj_cod = "..tonumber(cod)
                     DBExec(sql)
                     local resultado = DBRow()
                     if resultado and resultado.total then
                        tabela = tabela..'<td width="20%" align="center"><b>'..ponto_centavo(formata_valor(resultado.total))..'</b></td>\n'
                     else
                        tabela = tabela..'<td width="20%" align="center"><b>0,00</b></td>\n'
                     end
                  else
                     local sql = "SELECT valor_real FROM custo_previsto WHERE year(dt_prevista) = 200"..i.." AND month(dt_prevista) = "..j.." AND proj_cod = "..tonumber(cod)
                     DBExec(sql)
                     local resultado = DBRow()
                     if resultado and resultado.valor_real then
                        tabela = tabela..'<td width="20%" align="center">'..ponto_centavo(formata_valor(resultado.valor_real))..'</td>\n'
                     else
                        tabela = tabela..'<td width="20%" align="center">-</td>\n'
                     end
                  end
               end
            end
         end         
         if tonumber(num_anos) == 1 then
            tabela = tabela..'</tr>\n'
         end         
         i = i + 1
         num_anos = num_anos - 1
      end
      j = j + 1                       
   end   
   write('<table border="1" width="'..tamanho[num_anos_fixo]..'" align="center">\n')
   write(tabela)
   write('</table>\n')
end

function mostraInfoCustoPorMesAcomp ( cod )
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   local sql = "SELECT proj_dt_ini_prev, proj_dt_fim_prev, proj_dt_ini_real, proj_dt_fim_real FROM projeto WHERE proj_cod = "..tonumber(cod)
   DBExec(sql)
   local resultado = DBRow()
   if resultado and resultado.proj_dt_ini_prev then
     	proj_dt_ini_prev = resultado.proj_dt_ini_prev
   	  proj_dt_fim_prev = resultado.proj_dt_fim_prev
   	  if resultado.proj_dt_ini_real then
         proj_dt_ini_real = resultado.proj_dt_ini_real
      end
   	  if resultado.proj_dt_fim_real then
         proj_dt_fim_real = resultado.proj_dt_fim_real
      end        
   end
   tamanho   = {'30%', '50%', '70%', '90%'}
   tab_meses = {'jan','fev','mar','abr','mai','jun','jul','ago','set','out','nov','dez','total anual'}

   -- Mes e Ano Previstos 
   mes_ini_prev = strsub(proj_dt_ini_prev,4,5)
   ano_ini_prev = strsub(proj_dt_ini_prev,7,10)   
   mes_fim_prev = strsub(proj_dt_fim_prev,4,5)
   ano_fim_prev = strsub(proj_dt_fim_prev,7,10)  

   -- Datas INICIAIS: Atribui mes e anos minimos e maximos do projeto
   if proj_dt_ini_real and proj_dt_ini_real ~= '' and proj_dt_ini_real ~= ' ' then
      mes_ini_real = strsub(proj_dt_ini_real,5,6)
      if mes_ini_real < mes_ini_prev then
      	 mes_ini = mes_ini_real
      else
         mes_ini = mes_ini_prev
      end
      ano_ini_real = strsub(proj_dt_ini_real,0,4)
      if ano_ini_real < ano_ini_prev then
         ano_ini = ano_ini_real
      else
         ano_ini = ano_ini_prev         
      end
   else 
      mes_ini = mes_ini_prev
      ano_ini = ano_ini_prev
      mes_ini_real = mes_ini_prev
      ano_ini_real = ano_ini_prev
   end
   
   -- Datas FINAIS 
   if proj_dt_fim_real and proj_dt_fim_real ~= '' and proj_dt_fim_real ~= ' ' then
      mes_fim_real = strsub(proj_dt_fim_real,5,6)
      if mes_fim_real > mes_fim_prev then
      	 mes_fim = mes_fim_real
      else
         mes_fim = mes_fim_prev
      end
      ano_fim_real = strsub(proj_dt_fim_real,0,4)
      if ano_fim_real > ano_fim_prev then
         ano_fim = ano_fim_real
      else
         ano_fim = ano_fim_prev
      end
   else 
      mes_fim = mes_fim_prev
      ano_fim = ano_fim_prev
      mes_fim_real = mes_fim_prev
      ano_fim_real = ano_fim_prev
   end
   num_anos        = ( ano_fim - ano_ini ) + 1              
   ult_dig_ano_ini = strsub(ano_ini,4,4)
   ult_dig_ano_fim = strsub(ano_fim,4,4)
   num_anos_fixo   = num_anos   

   -- ---------------------------------------------------------------------------------------------
   -- EXIBICAO DOS CAMPOS REFERENTES AO CUSTO ANUAL (DATAS E VALORES) CASO TENHAM SIDO CADASTRADOS 
   -- --------------------------------------------------------------------------------------------- 
   tabela = ''  
   i      = strsub(ano_ini,4,4) 
   i_fixo = i

   -- ---------------------------------------------------------------------------------------------
   -- MONTA CABECALHO DA TABELA COM OS ANOS
   -- ---------------------------------------------------------------------------------------------
   write('<HR WIDTH=85%>\n' )
   write('<table border="0" align="center"><tr><td class="fieldLabel" align="center" colspan="2">Custo Previsto/Realizado por Ms</td></tr></table>\n' )   
   while num_anos > 0 do
      if tonumber(num_anos) == tonumber(num_anos_fixo) then                                 
         tabela = tabela..'<tr>\n'
         tabela = tabela..'<td width="20%"><b>Ms/Ano</b></td>\n'
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'(Prev.)</td>\n'
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'(Real.)</td>\n'
      else
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'(Prev.)</td>\n'                 
         tabela = tabela..'<td width="20%" align="center" class="fieldLabel">200'..i..'(Real.)</td>\n'                 
      end
      if tonumber(num_anos) == 1 then
         tabela = tabela..'</tr>\n'
      end
      i        = i + 1
      num_anos = num_anos - 1                 
   end
   
   -- ----------------------------------------------------------------------------------------------
   -- MONTA VALORES DA TABELA
   -- ---------------------------------------------------------------------------------------------- 
   j = 1
   while (tab_meses[j]) do
      i = i_fixo
      num_anos = num_anos_fixo
      while (num_anos > 0) do
      	 if (tonumber(num_anos) == tonumber(num_anos_fixo)) then
            tabela = tabela..'<tr>\n'
            tabela = tabela..'<td width="20%" class="fieldLabel">'..strupper(tab_meses[j])..'</td>\n'
     	   end
         -- -----------------------------------------------------------------------------------------------
         -- Custos PREVISTOS
      	 -- -----------------------------------------------------------------------------------------------
      	 if ((tonumber(i) < tonumber(strsub(ano_ini_prev,4,4))) or ((tonumber(i) == tonumber(strsub(ano_ini_prev,4,4))) and (tonumber(j) < tonumber(mes_ini_prev)))) then
            if (tonumber(j) == 13) then
               tabela = tabela .. '<td width="20%" align="center"><b>0,00</b></TD>\n'      	       
            else
               tabela = tabela .. '<td width="20%" align="center">n/a</TD>\n'      	       
            end
            
      	 elseif ((tonumber(i) == tonumber(strsub(ano_fim_prev,4,4))) and (tonumber(j) > tonumber(mes_fim_prev))) or (tonumber(i) > tonumber(strsub(ano_fim_prev,4,4))) then
      	    if (tonumber(j) == 13) then
               local sql = "SELECT SUM(valor_real) as valor_real FROM custo_previsto WHERE proj_cod = " .. cod .. " and year(dt_prevista) = 200" .. i
               DBExec(sql)
               local result = DBRow()
               if result and result.valor_real then
                  tabela = tabela .. '<td width="20%" align="center"><b>' .. ponto_centavo(formata_valor(result.valor_real)) .. '</b></TD>\n'      	             	    
               else
                  tabela = tabela .. '<td width="20%" align="center"><b>0,00</b></TD>\n'      	             	    
               end
      	    else
      	       tabela = tabela .. '<td width="20%" align="center">n/a</TD>\n'
      	    end
      	    
      	 else
      	    if (tonumber(j) == 13) then
      	       local sql = " SELECT sum(valor_real) as valor_real FROM custo_previsto WHERE year(dt_prevista) = 200"..i..
    	                     " AND proj_cod = " .. cod
    	         DBExec(sql)
    	         local result = DBRow()
               if result and result.valor_real then
                  tabela = tabela .. '<td width="20%" align="center"><b>' .. ponto_centavo(formata_valor(result.valor_real)) .. '</b></TD>\n'
               else
                  tabela = tabela .. '<td width="20%" align="center"><b>0,00</b></TD>\n'               
               end
            else
  	        local sql = " SELECT valor_real FROM custo_previsto WHERE year(dt_prevista) = 200"..i..
	                      " AND month(dt_prevista) = " .. j .. " AND proj_cod = " .. cod
	          DBExec(sql)
	          local result = DBRow()
               if result and result.valor_real then
                  tabela = tabela .. '<td width="20%" align="center">' .. ponto_centavo(formata_valor(result.valor_real)) .. '</TD>\n'
               else
                  tabela = tabela .. '<td width="20%" align="center">-</TD>\n'               
               end            
            end
      	 end
      	 
         -- ----------------------------------------------------------------------------------------------------
         -- Custos REALIZADOS
      	 -- ----------------------------------------------------------------------------------------------------
      	 if (tonumber(j) == 13) then
  	        local sql = " SELECT sum(valor_real) as valor_real FROM custo_realizado WHERE year(dt_realizacao) = 200"..i..
	                      " AND proj_cod = " .. cod
	          DBExec(sql)
	          local result = DBRow()
            if result and result.valor_real then
               tabela = tabela .. '<td width="20%" align="center"><b>' .. ponto_centavo(formata_valor(result.valor_real)) .. '</b></TD>\n'
            else
               tabela = tabela .. '<td width="20%" align="center"><b>0,00</b></TD>\n'               
            end      	    
      	 else
      	    local sql = " SELECT sum(valor_real) as valor_real FROM custo_realizado WHERE year(dt_realizacao) = 200"..i..
	                      " AND month(dt_realizacao) = " .. j .. " AND proj_cod = " .. cod
	          DBExec(sql)
	          local result = DBRow()
            if result and result.valor_real then
               tabela = tabela .. '<td width="20%" align="center">' .. ponto_centavo(formata_valor(result.valor_real)) .. '</TD>\n'
            else
               tabela = tabela .. '<td width="20%" align="center">-</TD>\n'               
            end
         end         
      	 if (tonumber(num_anos) == 1) then
      	    tabela = tabela .. '</tr>\n'
      	 end
      	 i = i + 1
      	 num_anos = num_anos - 1
      end
      j = j + 1
   end   
   write('<table border="0" width="100%">\n' )
   write('<tr><td width=10>&nbsp;</td><td>\n' )
   write('<center><table border="1" width="'..tamanho[num_anos_fixo]..'">\n')
   write(tabela)
   write('</table></center>\n')
   write('</td></tr></table>\n' )
end

function AtualizaCustoPorMes ( cod )
   write( '<BR>\n' )
   write( '<TABLE BORDER="0">\n' )
   diaatual = date("%d")
   if (strsub(diaatual,0,1) == '0') then
      diaatual = strsub(diaatual,2,3)
   end                               
   mesatual = date("%m")
   if (strsub(mesatual,0,1) == '0') then
      mesatual = strsub(mesatual,2,3)
   end   
   anoatual = date("%Y")
   write( '<TR><TD COLSPAN=3><B>ltima atualizao</B></TD></TR>\n' )
   ultimadata = {}
   ultimadatatemp = {}
   -- ---------------------------------------------------------------------------------------------------------
   -- Busca os valores da tabela CUSTO_REALIZADO, exibindo as informacoes em "Ultima atualizacao" referentes a 
   -- ultima insercao no campo VALOR_REAL (usando DESC)
   -- ---------------------------------------------------------------------------------------------------------
   ultimadatatemp = ConsultaBD2("custo_realizado","*","proj_cod = "..cod," proj_cod, dt_realizacao, seq_real DESC ")
   i = 1
   j = 1
   -- -----------------------------------------------------------------------------------
   -- PEGA DATAS DO ANO ATUAL 
   -- -----------------------------------------------------------------------------------
   if ultimadatatemp[1].valor_real then
      while ultimadatatemp[i] do
         if strfind(ultimadatatemp[i].dt_inclusao,anoatual) then
            ultimadata[j] = ultimadatatemp[i]
            j = j + 1
         end
         i = i + 1
      end
   end   
   i = 1
   dt_ultima_atualizacao = 0
   if ultimadata[i] then
      acumulador_data_realizacao = inclui_data(strsub(ultimadata[1].dt_realizacao,0,10))
      acumulador_data_inclusao = inclui_data(strsub(ultimadata[1].dt_inclusao,0,10))
      acumulador_seq  = ultimadata[1].seq_real
   end
   temp = {}
   while ultimadata[i] do
      temp_data_realizacao = inclui_data(strsub(ultimadata[i].dt_realizacao,0,10))
      temp_data_inclusao = inclui_data(strsub(ultimadata[i].dt_inclusao,0,10))
      temp_seq = ultimadata[i].seq_real
      if (temp_data_realizacao > acumulador_data_realizacao) then
         acumulador_data_realizacao = temp_data_realizacao   
         acumulador_data_inclusao = temp_data_inclusao
         ultimo_valor = ultimadata[i].valor_real
      end
      if ((temp_data_realizacao == acumulador_data_realizacao) and (temp_seq >= acumulador_seq)) then
         acumulador_data_realizacao = temp_data_realizacao   
         acumulador_data_inclusao = temp_data_inclusao
         ultimo_valor = ultimadata[i].valor_real         
         acumulador_seq = temp_seq
      end            
      i = i + 1
   end                    
   if acumulador_data_realizacao then
      acumulador_data_realizacao = formataData2(acumulador_data_realizacao)  
   else
      acumulador_data_realizacao = ''
   end
   if acumulador_data_inclusao then
      acumulador_data_inclusao = formataData2(acumulador_data_inclusao)
   else
      acumulador_data_inclusao = ''
   end
   if ultimo_valor then
      ultimo_valor = 'R$ '..ponto_centavo( formata_valor(ultimo_valor) )      
   else
      ultimo_valor = ''
   end
   write( '<TR><TD colspan="2">Data de realizao: <B>',acumulador_data_realizacao,'</B></TD><TD>Valor: <B>',ultimo_valor,'</B></TD></TR>\n' )                                                                                                                                                                                                                                                                                                                                                                                          
   write( '<TR><TD COLSPAN=3>Data de incluso: <B>',acumulador_data_inclusao,'</B></TD></TR>\n' )
   write( '<TR><TD COLSPAN=3>&nbsp</TD></TR>\n' )   
   if cgi.msg_data_inclusao or cgi.msg_custoReal then
      write( '<TR><TD><B><A HREF=Javascript:window.top.abre_hint("hint_Custo_realizado_em_Acompanhamento_de_Projeto__")><font color=black>Custo realizado em</font></a></B></td><td  align="middle">&nbsp;&nbsp;<INPUT TYPE="text" NAME="data_inclusao" VALUE="'..cgi.data_inclusao..'" SIZE="13" MAXLENGTH="13" onChange="javascript:comparaDataCusto();"></B>: </TD><TD  align="middle"><INPUT TYPE="text" NAME="custoatual" SIZE="13" MAXLENGTH="13" VALUE="'..cgi.custoatual..'" onChange="javascript:formataCustoReal();"></TD></TR>\n' )
      write( '<TR valign="center"><TD>&nbsp;</TD><TD align="middle">(dd/mm/aaaa)</td><td align="middle">R$</td></TR>\n' )
   else
      write( '<TR><TD><B><A HREF=Javascript:window.top.abre_hint("hint_Custo_realizado_em_Acompanhamento_de_Projeto__")><font color=black>Custo realizado em </font></a></B></td><td  align="middle">&nbsp;&nbsp;<INPUT TYPE="text" NAME="data_inclusao" SIZE="10" MAXLENGTH="10" onChange="javascript:comparaDataCusto();"></B>: </TD><TD align="middle"><INPUT TYPE="text" NAME="custoatual" SIZE="13" MAXLENGTH="13" onChange="javascript:formataCustoReal();"></TD></TR>\n' )
      write( '<TR align="middle"><TD>&nbsp;</TD><TD>(dd/mm/aaaa)</td><td align="middle">R$</td></TR>\n' )      
   end
   
   if cgi.msg_data_inclusao then
      write( '<TR><TD COLSPAN=3><FONT CLASS=msgErro>',cgi.msg_data_inclusao,'</TD></TR>\n' )
   end 
   
   if cgi.msg_custoReal then
      write( '<TR><TD COLSPAN=3><FONT CLASS=msgErro>',cgi.msg_custoReal,'</TD></TR>\n' )
   end 
   
   write( '<TR><TD COLSPAN=3><font color="green"><i>\n' )
   write( 'No dia 09 de janeiro de 2002 os valores informados em Reais mil foram alterados para Reais.<br>\n' )
   write( 'A partir desta data todos os campos que se referem a custo devero ser preenchidos em Reais.\n' )
   write( '</i></font></TD></TR>\n' )
    
   write( '<TR><TD COLSPAN=3>&nbsp</TD></TR>\n' )
   totalmes = {}
   totalmes = ConsultaBD2("custo_realizado","SUM(valor_real) as sum_total","proj_cod = "..cod .. 
                          " AND DATEPART(month,dt_realizacao) = " .. mesatual ..
                          " AND DATEPART(year, dt_realizacao) = " .. date("%Y"),nil)
   contador_mes_atual = 0
   if totalmes[1] then
      contador_mes_atual = totalmes[1].sum_total
   end    
   mes = date("%m")
   tab = {'Janeiro','Fevereiro','Maro','Abril','Maio','Junho','Julho','Agosto','Setembro','Outubro','Novembro','Dezembro'}
   i = 1
   while tab[i] do
      if tonumber(mes) == tonumber(i) then
         mes = tab[i]
      end               	
      i = i + 1
   end 
   if not contador_mes_atual or contador_mes_atual == '' then
      contador_mes_atual = 0
   end
   write( '<TR><TD><B>Total do ms de ',mes,'</B>: </TD><TD colspan="2"><B>R$ ',ponto_centavo(formata_valor(contador_mes_atual)),'</B></TD></TR>\n' )
   write( '</TABLE>\n' )
end

function atualizaInfoCustoProj( cod , func )   
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   local sql = "SELECT proj_cod FROM custo_previsto WHERE proj_cod = "..cod   
   DBExec(sql)
   local resultado = DBRow()
   
   -- -------------------------------------------------------------------------
   -- Se existem valores cadastrados em CUSTO_PREVISTO (custo previsto mensal)
   -- -------------------------------------------------------------------------
   if resultado and resultado.proj_cod then
      -- ----------------------------------------------------------------------
      -- Verifica se existem valores cadastrados em CUSTO_REALIZADO 
      -- ----------------------------------------------------------------------     	
   	  local sql = "SELECT proj_cod FROM custo_realizado WHERE proj_cod = "..cod   
      DBExec(sql)
      local resultado = DBRow()      
      -- -------------------------------------------------------------------------------
      -- Escolhe a funcao de exibicao de custo de acordo com o resultado da query acima
      -- -------------------------------------------------------------------------------      
   	  if resultado and resultado.proj_cod then   	
         mostraInfoCustoPorMesAcomp ( cod )
      else
         mostraInfoCustoPorMes ( cod )
      end      
      if func == 'acompanha' then
         AtualizaCustoPorMes ( cod )  
      end          	
   else   
      local i,j
      local result = retornaCustoParcial( cod )
      local total_prev = 0
      local total_real = 0   
      write('<hr width="85%">\n' )
      write('<table border="0" align="center"><tr><td class="fieldLabel" align="center" colspan="2">Custo Previsto/Realizado Anual</td></tr></table>\n')         
      write('<table border="1" align="center" width="70%">\n')   
      write( '<TR>\n' )
      write( '<TD ALIGN=CENTER width="15%"><B>Ano</B></TD>\n' )
      write( '<TD ALIGN=CENTER><B>Custo Previsto</B></TD>\n' )
      write( '<TD ALIGN=CENTER><B>Custo Realizado</B></TD>\n' )
      write( '</TR>\n' )      
      if (result[1] and result[1].custo_ano) then
         i = 1
         while (result[i]) do
            write( '<TR>\n' )
            write( '<TD ALIGN=center><B>' .. result[i].custo_ano .. '</B></TD>\n' )         
            if (result[i].custo_prev_ano) then
               custo_prev_ano = result[i].custo_prev_ano
            else
               custo_prev_ano = 0
            end 
            write( '<TD ALIGN=right>' .. ponto_centavo(formata_valor(custo_prev_ano)) .. '</TD>\n' )
            
            local sql = "SELECT sum(valor_real) as custo_realizado_ano FROM custo_realizado WHERE year(dt_realizacao) = "..
                        result[i].custo_ano .. " AND proj_cod = " .. cod
            DBExec(sql)
            local custo = DBRow()
            if (custo and custo.custo_realizado_ano) then
               custo_realizado_ano = custo.custo_realizado_ano
            else
               custo_realizado_ano = 0
            end	          
	          write( '<TD ALIGN=right>' .. ponto_centavo(formata_valor(custo_realizado_ano)) .. '</TD>\n' )	    
            total_real = total_real + custo_realizado_ano	
            total_prev = total_prev + custo_prev_ano	
            i = i + 1	
         end
      end            
      write( '<TR><TD ALIGN=CENTER><B>Custo Total</B></TD>\n' )
      write( '<TD align="right" width=50%><B>' .. ponto_centavo(formata_valor(total_prev)) .. '</B>&nbsp;</TD>\n' )
      write( '<TD align="right" width=50%><B>' .. ponto_centavo(formata_valor(total_real)) .. '</B>&nbsp;</TD></TR>\n' )
      write( '</TABLE>\n' )         
      AnoAtual = date("%Y")   
      if func == 'acompanha' then
         AtualizaCustoPorMes ( cod )  
      end   
   end
end  