dofile( "lua/acessabd.lua" )


--Entrada: cdigo do projeto
--Saida: cdigo da classificao 
function retornaCodClasProj( cod )
   local result = {}
   if ( cod ) then   
      result = ConsultaBD2( "proj_ot", "clas_cod", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

--Entrada: cdigo do projeto
--Saida: cdigo da OT da classificao 
function retornaCodOTClasProj( cod )
   local result = {}
   
   if ( cod ) then   
      result = ConsultaBD2( "proj_ot", "ot_cod", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

--Entrada: cdigo do projeto
--Saida: cdigo da subclassificao 
function retornaCodSubClasProj( cod )
   local result = {}
   
   if ( cod ) then   
      result = ConsultaBD2( "proj_ot", "proj_ot_subcl_cod", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
          result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

--Entrada: cdigo do projeto
--Saida: cdigo da OT da subclassificao(o resultado pode ser nulo)
function retornaCodOTSubClasProj( cod )
   local result = {}
   
   if ( cod ) then   
      result = ConsultaBD2( "proj_ot", "proj_ot_ot_subclas", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end


--Entrada: cdigo do projeto
--Saida: cdigo da OT operacional (estar automaticamente relacionada a classificao ou subclassificao)
function retornaCodOTOperProj( cod )
   local result = {}
   
   if ( cod ) then   
      result = ConsultaBD2( "proj_ot", "ot_oper_cod", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

--Entrada: cdigo do projeto
--Sada : descrio da OT Especfica
function retornaOtEspProj( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "projeto", "proj_num_ote", "proj_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Projeto Invlido!'
   end
end

--Entrada: cdigo da classificao ou subclassificao
--Sada : descrio da Classificao ou Subclassificao
function retornaNomeClas( cod )
   local result = {}

   if ( cod ) then
      result = ConsultaBD2( "classificacao", "clas_descr", "clas_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Classificao ou Subclassificao Invlida!'
   end
end


--Entrada: cdigo da OT da classificao ou da subclassificao
--Sada : descrio da OT da Classificao ou da Subclassificao
function retornaOTClas( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "ot", "ot_chave", "ot_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Classificao ou Subclassificao Invlida!'
   end
end

--Entrada: cdigo da OT Operacional (relacionada a classificao ou a subclassificao)
--Sada : descrio da OT Operacional
function retornaOTOper( cod )
   local result = {}

   if ( cod ) then   
      result = ConsultaBD2( "ot_oper", "ot_oper_chave", "ot_oper_cod = '" .. cod .. "'" , nil )
      if ( not result[1][1] ) then
         result[1][1] = ''
      end
      return result[1][1]
   else
      return 'Cdigo de Classificao ou Subclassificao Invlida!'
   end
end
