------------------------------------------------------------------------------
--Tabelas que associam identificadores de erro a uma configurao de mensagem
--'C' = 'Ao Corretiva' e 'D' = 'Diagnstico'
------------------------------------------------------------------------------
-------------------------------------------------------------------------------
--Erros associados a campos da classe CampoLimitadoInterface
-------------------------------------------------------------------------------
CampoLimitadoInterface.configuracaoMsgErro = { campo_obrigatorio_vazio = cgi.configuracao }


-------------------------------------------------------------------------------
--Erros associados a campos da classe CampoIlimitado
-------------------------------------------------------------------------------
CampoIlimitado.configuracaoMsgErro = { 	restricao_tamanho_insatisfeita = cgi.configuracao }

-------------------------------------------------------------------------------
--Erros associados a campos da classe CampoSimples
-------------------------------------------------------------------------------
CampoSimples.configuracaoMsgErro = 
{ 
	campo_obrigatorio_vazio = cgi.configuracao,
	tipo_invalido = cgi.configuracao,
	limite_ultrapassado = cgi.configuracao,
	restricao_tamanho_insatisfeita = cgi.configuracao,
	valor_invalido = cgi.configuracao,
	chave_ja_cadastrada = cgi.configuracao
} 

-------------------------------------------------------------------------------
--Erros associados a campos da classe CampoData
-------------------------------------------------------------------------------
CampoData.configuracaoMsgErro = CampoSimples.configuracaoMsgErro

CampoData.configuracaoMsgErro.dia_invalido = cgi.configuracao
CampoData.configuracaoMsgErro.mes_invalido = cgi.configuracao
CampoData.configuracaoMsgErro.dia_fevereiro_acima_limite = cgi.configuracao
CampoData.configuracaoMsgErro.dia_maior_que_30 =cgi.configuracao
CampoData.configuracaoMsgErro.data_incompleta = cgi.configuracao

-------------------------------------------------------------------------------
--Erros associados a campos da classe CampoEstruturado
-------------------------------------------------------------------------------
CampoEstruturado.configuracaoMsgErro = 
{
	--Esta primitiva  usada quando se quer retornar uma mensagem de erro vazia para 
	--campos estruturados, em casos onde no ser gerada mensagem global, porm mensa
	--gens locais foram geradas
	erro_campo_estruturado = nil,
	restricao_tamanho_insatisfeita = cgi.configuracao,
	componentes_invalidos = cgi.configuracao,
	restricao_tamanho_insatisfeita_componentes_invalidos = cgi.configuracao
}
