import java.awt.*;

public class Square extends LegendMark {
  // pos = upperleft; size = side 
  int size;

  Square(Color color)
  {
    this.size = 15;
    this.color = color;
  }

  Square(int size, Color color)
  {
    this.size = size;
    this.color = color;
  }

  Square(Point position, int size, Color color)
  {
    this.position = position;
    this.size = size;
    this.color = color;
  }

  void setPosition(Point position)
  {
    this.position = position;
  }

  void draw(Graphics g)
  {
    Color currentColor;

    currentColor = g.getColor();
    g.setColor(color);
    g.fillRect(position.x, position.y, size, size);

    // restore
    g.setColor(currentColor);
  } 

  int width()
  {
    return(size);
  }

  int height()
  {
    return(size);
  }
}
