-- -------------------------------------------------------------------------------------------------
-- $Revision:$ 
--
-- $Update Date:$ $NoKeywords:$
-- 
-- Copyright by TeCGraf (PUC-RIO)
-- -------------------------------------------------------------------------------------------------
-- Esse SCRIPT deve ser executado no servidor atraves do WINAT nos dias 05 e 10 de cada ms
-- -------------------------------------------------------------------------------------------------
-- Varre a tabela de pessoal enviando e-mail a todos os usuarios do sistema lembrando a necessidade
-- de se atualizar os projetos CLASSE I
-- -------------------------------------------------------------------------------------------------    
   
-- -------------------------------------------------------------------------------------------------
-- Abre conexao com o Banco de Dados se ela jah nao estiver aberta
-- -------------------------------------------------------------------------------------------------        
   if ESTADO_BD ~= 'aberto' then
      AbreBD()
   end
   
-- -------------------------------------------------------------------------------------------------
-- DEFININDO VALORES
-- -------------------------------------------------------------------------------------------------
-- -------------------------------------------------------------------------------------------------
-- Descobre o e-mail do responsavel pelos projetos CLASSE I
-- -------------------------------------------------------------------------------------------------
   local sql_origem = "SELECT pes_email FROM pessoal WHERE pes_chave = '".._CHAVE_PROJ_CLASSE_I_.."'"
   DBExec(sql_origem)  
   origem = DBRow().pes_email  
   
-- -------------------------------------------------------------------------------------------------
-- DEFININDO DATAS
-- -------------------------------------------------------------------------------------------------   
   dia_num = date('%d')
   mes_ano = date('%m/%Y')   -- retorna mes e ano atual           
   
   titulo   = 'Acompanhamento do PEGASO'    
   mensagem = "Senhores,\n\n"..
                    "Gostaramos de relembr-los que, segundo os procedimentos e fluxo de "..
                    "comunicao definidos para controle e acompanhamento do PEGASO, no prximo "..
                    "dia 15/" ..mes_ano..", realizaremos a emisso do relatrio de acompanhamento "..
                    "mensal do programa para em seguida, iniciarmos as anlises sobre os "..
                    "resultados obtidos. Os resultados das anlises estaro disponveis e sero "..
                    "divulgados a partir do dia 26/" ..mes_ano..".\n\n"..

                    "Em face do exposto, ressaltamos que  de suma importncia que os projetos "..
                    "Classe I cadastrados no sistema Carteira de Projetos, o qual est "..
                    "disponvel no site da rea de SMS na Intranet, sejam adequadamente "..
                    "atualizados at o dia 14/" ..mes_ano.. ".\n\n"..

                    "Assim, aproveitamos a oportunidade para reforar que estamos a sua "..
                    "disposio para esclarecer dvidas quanto  utilizao do sistema ou no "..
                    "entendimento dos procedimentos,\n".. 
                    
                    	"\n\t\tGrupo de Gesto do Pegaso."    
   
   -- -------------------------------------------------------------------------------------------------
   -- Se estamos nos dias 05 ou 10 do mes entao
   -- -------------------------------------------------------------------------------------------------   
      if tonumber(dia_num) == 5 or tonumber(dia_num) == 10 then 
         
         write('<br><b><font color="blue">O envio de e-mail para todos os usurios cadastrados na tabela PESSOAL foi efetuado em '..
                date("%d/%m/%Y")..'.</b></font>')  
              
         sql = "SELECT pes_cod, pes_email FROM pessoal ORDER BY pes_cod"        
         DBExec(sql)           
         pessoal = DBRow()
         
         while pessoal do 
            local destino = ''
            if pessoal.pes_email then 
               destino = pessoal.pes_email
            end           
                             	  
            -- Chama a funo de envio de e-mail (envia_mail()) atraves da funo ENVIA_EMAIL definida
            -- em CONSTANTES.LUA
            local ok, msgerr =  ENVIA_EMAIL(destino, origem, titulo, mensagem, '')                           
            
            if not ok then      
            	 write('<br><br><font color="red"><i>O(s)  e-mail de notificao referente ao usurio (cdigo: <b>'..
                      pessoal.pes_cod..'</b>) no pode ser enviado </i>')          	
               if msgerr then 
                  write('(erro: <b>'..msgerr..'</b>).') 
               end   
            else 
               write('<br><br><font color="blue"><i>O e-mail de notificao referente ao usurio (cdigo: <b>'..
                      pessoal.pes_cod..'</b>) foi enviado com sucesso!</i>')
            end             
                             
            pessoal = DBRow()
         end  -- while tiver linha na tabela  
     
     else  -- (se nao estamos nos dias 05 ou 10)                                    
        
        write('<br><font color="red"><b>O envio de e-mail para todos os usurios cadastrados na tabela PESSOAL '..
              's pode ser efetuado nos dias 05 e 10 de cada ms,<BR> hoje estamos no dia '..
              date("%d/%m/%Y")..'.</b></font>')  
        
     end