-- -------------------------------------------------------------------------------------------
-- FORM_ATIVIDADES.LUA
-- -------------------------------------------------------------------------------------------
cgi.descricao_ativ = gsub(cgi.descricao_ativ,"'",'"')
-- -------------------------------------------------------------------------------------------
-- Tratamento do preenchimento do campo ALERTA
-- O valor do campo deve ser um inteiro menor ou igual a Data de Trmino Previsto e a Data
-- de Incio Previsto
-- -------------------------------------------------------------------------------------------
   assert(dofile( "global.lua" ))

-- -------------------------------------------------------------------------------------------
-- Inicializa as variveis utilizadas na validao do campo ALERTA
-- -------------------------------------------------------------------------------------------
   limite_alerta = 0
   dif           = 0
      
-- -------------------------------------------------------------------------------------------
-- Faz a diferena entre as datas de trmino e incio no formato dd/mm/aaaa se essas datas
-- existirem
-- DiasEntre() (GLOBAL.LUA) retorna o numero de dias entre as datas passadas, e nao a 
-- diferenca entre elas, por isso eh que limite_alerta recebe DiasEntre() - 1
-- -------------------------------------------------------------------------------------------  
   if cgi.erro_data == 'no'and temConteudo(cgi.dt_fim_prevista_ativ) and temConteudo(cgi.dt_ini_prevista_ativ) then    
      limite_alerta = DiasEntre(cgi.dt_ini_prevista_ativ, cgi.dt_fim_prevista_ativ) - 1   
   end    
   
form_atividades = Formulario:new 
{{
      CampoCaracter:new { 'descrio', "descricao_ativ","sim", nil, nil, cgi.descricao_ativ}, 

	    CampoData:new 
       {
          'Data prevista para o Inicio', 'dt_ini_prevista_ativ', 'sim',
          { 
             limite = 
             { 
                ['>='] = 
                { 
                   nome = 'um de Abril de 2000', valor = "20000401" 
                },

                ['<='] = 
                { 
                   nome = 'trinta e um de Dezembro de 2003', valor = "20031231" 
                } 
             } 
          }, nil, 
	       cgi.dt_ini_prevista_ativ, "texto" 
	    }, 

            
	    CampoData:new 
       {
          'Data prevista para o fim', 'dt_fim_prevista_ativ', 'sim',
          { 
             limite = 
             { 
                ['>='] = 
                { 
                   nome = 'um de Abril de 2000', valor = "20000401" 
                },

                ['<='] = 
                { 
                   nome = 'trinta e um de Dezembro de 2003', valor = "20031231" 
                }
             } 
          }, nil, 
	       cgi.dt_fim_prevista_ativ, "texto" 
	    }, 
	    
	   CampoInteiro:new 
	   {
	      'Alerta', 'alerta', 'sim', 
	      {
	         limite = 
             { 
                ['>='] = 
                { 
                   nome = '0', valor = 0 
                },
                
                ['<='] = 
                { 
                   nome = 'nmero de dias previstos para a atividade, ou seja, Data de Trmino Previsto - Data de Incio Previsto', valor = limite_alerta
                }                
             }
          }, nil, cgi.alerta 
	    },
	   
	   CampoInteiro:new 
	   {
	      'Peso', 'peso', 'sim', 
	      {
	         limite = 
             { 
                ['>'] = 
                { 
                   nome = '0', valor = 0
                },

                ['<='] = 
                { 
                   nome = '100', valor = 100 
                } 
             }
          }, nil, cgi.peso 
        },
	   
}}	
