assert(dofile("lua/global.lua"))

-- usada com os valores de custo previsto e custo realizado
function valImpressao(valor)
  if temConteudo( valor ) then
     valor = ponto_centavo( formata_valor(valor) )
     return valor
  else
     return "0,00"
  end
end

function valDataSql(valor)  
  if temConteudo(valor) then    
    if strfind(valor,"([ %w]*)/([ %w]*)/([ %w]*) ") then
      i,f,d,m,a = strfind(valor,"([ %w]*)/([ %w]*)/([ %w]*) ")
      return "'"..tostring(tonumber(a)).."-"..tostring(tonumber(m)).."-"..tostring(tonumber(d)).."'"
    else      
      i,f,a,m,d = strfind(valor,"(%d%d%d%d)(%d%d)(%d%d)")
      return "'"..a.."-"..m.."-"..d.."'"
    end
  else
    return "null"
  end
end

function valDataImpressao(valor)
  if temConteudo(valor) then    
    if strfind(valor,"([ %w]*)/([ %w]*)/([ %w]*) ") then
      return formataData(valor)
    else           
      --i,f,a,m,d = strfind(valor,"(%d%d%d%d)(%d%d)(%d%d)")
      return formataData2(valor)
    end
  else
    return "-"
  end
end
  
function valNumeroSql(valor)
  if valor then
    return valor
  else
    return "null"
  end
end

function valSql(valor, isString)
  if temConteudo(valor) then
    if isString then
      return "'"..valor.."'"
    else
      return valor
    end
  else
    return "null"
  end
end

function valAprovada(valor)
  if valor then
    if valor == 0 then
      return "Reprovada"
    else
      return "Aprovada"
    end
  else
    return "No Avaliada"
  end
end