function grava_cons_perso()
   dofile("cons_perso.lua")
   dofile("global.lua")

   dados = {}
   i     = 1    

   if temConteudo( cgi.recebe_orgao ) then
      dados[i] = {}
      dados[i].campo   = 'org_cod'
      dados[i].valores = cgi.recebe_orgao
      i = i + 1
   end
   if temConteudo( cgi.recebe_unidade ) then
      dados[i] = {}
      dados[i].campo   = 'unid_cod'
      dados[i].valores = cgi.recebe_unidade
      i = i + 1
   end
   if temConteudo( cgi.recebe_gerencia ) then
      dados[i] = {}    
      dados[i].campo   = 'ger_cod'      
      dados[i].valores = cgi.recebe_gerencia
      i = i + 1
   end    
   if temConteudo( cgi.recebe_classificacao ) then
      dados[i] = {}
      dados[i].campo   = 'clas_cod'                    -- TABELA proj_ot
      dados[i].valores = cgi.recebe_classificacao
      i = i + 1
   end
   if temConteudo( cgi.recebe_subclassificacao ) then
      dados[i] = {}
      dados[i].campo   = 'proj_ot_subcl_cod'           -- TABELA proj_ot
      dados[i].valores = cgi.recebe_subclassificacao
      i = i + 1
   end
   if temConteudo( cgi.metas ) then
      dados[i] = {}    
      dados[i].campo   = 'metas'                       -- campo proj_meta (TABELA projeto)
      dados[i].valores = cgi.metas
      i = i + 1   	
   end   
   if temConteudo( cgi.cod_usuario ) then
      dados[i] = {}    
      dados[i].campo   = 'proj_cod_usuario'      
      dados[i].valores = cgi.cod_usuario 
      i = i + 1
   end  
   if temConteudo( cgi.status ) then
      dados[i] = {}
      dados[i].campo   = 'stat_cod'      
      dados[i].valores = cgi.status
      i = i + 1
   end  
   if temConteudo( cgi.desempenho ) then
      dados[i] = {}    
      dados[i].campo   = 'desempenho'                 -- campo proj_desempenho (TABELA projeto) 
      dados[i].valores = cgi.desempenho
      i = i + 1
   end        
   if temConteudo( cgi.prioridade ) then
      dados[i] = {}
      dados[i].campo   = 'proj_prior'
      dados[i].valores = cgi.prioridade
      i = i + 1
   end
   if temConteudo( cgi.plano_rec ) then
      dados[i] = {}    
      dados[i].campo   = 'proj_plano_rec'      
      dados[i].valores = cgi.plano_rec
      i = i + 1      
   end   
   if temConteudo( cgi.plano_dut ) then
      dados[i] = {}    
      dados[i].campo   = 'proj_paeid'          
      dados[i].valores = cgi.plano_dut
      i = i + 1      
   end    
   if temConteudo( cgi.class_acompanhamento ) then
      dados[i] = {}    
      dados[i].campo   = 'proj_class'          
      dados[i].valores = cgi.class_acompanhamento  
      i = i + 1          
   end 
      
-- --------------------------------------------------------------------------------------------------------------------   
-- A tabela DADOS[] armazena os campos e os valores que iro compor a condio ( WHERE ) para a consulta
-- Pela forma como a CONSULTA foi implementada, ocorriam alguns problemas na comparao dos campos de data, dessa
-- forma foi necessrio criar um artifcio para corrigir esse problema.
-- O artifcio utilizado foi a forar o campo de data no formato ( AAAAMMDD ) a assumir o tipo char para efetuar 
-- a comparao 
-- "CAST ( campo_data AS CHAR )" 
-- --------------------------------------------------------------------------------------------------------------------   
-- Os valores das datas devem estar no formato AAAAMMDD, o que  feito pela funo INCLUI_DATA()
-- --------------------------------------------------------------------------------------------------------------------          
   if temConteudo( cgi.data_inicio_previsto ) then
      dados[i] = {}
      dados[i].campo   = 'proj_dt_ini_prev'
      dados[i].valores = cgi.data_inicio_prev .. ' cast( ' .. inclui_data( cgi.data_inicio_previsto ) .. ' as char) '      
      i = i + 1
   end
   if temConteudo( cgi.data_termino_previsto ) then
      dados[i] = {}    
      dados[i].campo   = 'proj_dt_fim_prev'
      dados[i].valores = cgi.data_termino_prev .. ' cast( ' .. inclui_data( cgi.data_termino_previsto ) .. ' as char) '      
      i = i + 1
   end
   if temConteudo( cgi.data_inicio_real ) then
      dados[i] = {}      
      dados[i].campo   = 'proj_dt_ini_real'
      dados[i].valores = cgi.data_in_real .. ' cast( ' .. inclui_data( cgi.data_inicio_real ) .. ' as char) '      
      i = i + 1
   end
   if temConteudo( cgi.data_termino_real ) then
      dados[i] = {}    
      dados[i].campo   = 'proj_dt_fim_real'      
      dados[i].valores = cgi.data_term_real .. ' cast( ' .. inclui_data( cgi.data_termino_real ) .. ' as char) '      
      i = i + 1
   end 
   
   -- Soh eh utilizado no FORM de relatorio   
   if temConteudo( cgi.recebe_informacoes ) then
      dados[i] = {}    
      dados[i].campo   = 'informacoes'      
      dados[i].valores = cgi.recebe_informacoes
     i = i + 1
   end           

   return ( gravaConsultaPersonalizada( cgi.nome_cons_perso, dados ) )
end